package de.intevation.gnv.geobackend.base.query;

import de.intevation.gnv.geobackend.base.Result;

import de.intevation.gnv.geobackend.base.query.exception.QueryException;

import java.util.Collection;

/**
 * This Interface provides the Method to execute Queries
 * against a Datastore eg. Databases
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public interface QueryExecutor {


    /**
     * This Method executes the Query an returns the Result
     * in an Collection.
     * @param queryID the ID of the Query which should be used.
     * @param filter the Filterarguments to limit the Data
     * @return the fetched Values
     * @throws QueryException
     */
    Collection<Result> executeQuery(String queryID, String[] filter) throws QueryException;

    Collection<Result> cachedResults(String query);

    void cacheResults(String query, Collection<Result> results);
}
